/****************************************************************
ConfigClient.h
CS 481 - Team E
Spring 1998
Hummingbird Project - Dr. Frincke
Coded by: Jamie Marconi
Description: This is the class definition to the client half of the 
             configuration propagation system. The client connects to
	     the server of the subordinates and send the correct tabls.
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _ConfigClient_h
#define _ConfigClient_h

#include "Hummer.h"             // Global hummer defines
#include <sock_cli.h>          // Connection socket object

class ConfigClient
{
  // Data;
 private:
  sock_cli *ConnectedSocket; 

  // Methods;
  int OpenServer(char *SubName);
  int CloseServer();
  int PushLevels();
  int PushFilters();
  int PushAccept();
  int PushForward();  
  int PushKill();
  
 public:
  ConfigClient();
  ~ConfigClient();
  int PushConfig(void);

};
  
#endif
