/****************************************************************
Hummer.h
CS 481 - Team A
Spring 1997
Hummingbird Project - Dr. Frincke
Coded by: Pete Neisen
Description: This file is included by all of the hummer components. It is
             where all of the constant defines are made.
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _Hummer_h
#define _Hummer_h

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <netdb.h>
#include <sys/param.h>
#include <sys/errno.h>

#include "version.h"

// String lengths
#define NORMAL_STRING_SIZE 256
#define BUFFER_SIZE 1024
#define IP_ADDRESS_SIZE MAXHOSTNAMELEN
#define DATE_SIZE 10
#define TIME_SIZE 8
#define LEVEL_SIZE 2

// Special defines
#define SERVER_LISTEN_BACKLOG 10
#define MAX_MESSAGE_AGE 20
#define DEFAULT_TRUST 5
#define DEFAULT_COOP 5
#define DEFAULT_INTEG 5
#define DEFAULT_TIME 30

// Files
#ifndef POSTGRES
#define LOCAL_MESSAGE_FILE "message.loc"
#define INHERITED_MESSAGE_FILE "message.inh"
#define PROPAGATED_MESSAGE_FILE "message.locinh"
#define LOCAL_TRUST_FILE "trust.loc"
#define INHERITED_TRUST_FILE "trust.inh"
#define PROPAGATED_TRUST_FILE "trust.locinh"
#define MANAGER_FILE "manag.info"
#define SUBORDINATE_FILE "subord.info"
#define TIME_FILE "time.info"
#define LOG_FILE "hummer.log"
#define CONFIG_SERVER_PID_FILE "ConServ.pid"
#define CONFIG_CLIENT_PID_FILE "ConClient.pid"
#define SERVER_PID_FILE "Server.pid"
#define PASSWORD_FILE ".pass"
#endif

// Ports
#define MESSAGE_PORT 15001
#define CONFIG_PORT 15002
#define ALERT_INTERFACE_PORT 15003
#define PEER_PORT 15004

// Kerberos Constants
#define MESSAGE_SERVICE "hummingbird"
#define MESSAGE_KEYTAB "srvtab.hummingbird"
#define CONFIG_SERVICE "hummingbird"
#define CONFIG_KEYTAB "srvtab.hummingbird"
#define PEER_SERVICE "hummingbird"
#define PEER_KEYTAB "srvtab.hummingbird"
#define ALERT_INTERFACE_SERVICE "hummingbird"

// PostgreSQL stuff
#define DBNAMEPRE "hummer_"

// Log file names
// #define HUMMER_LOG "/tmp/Hummer.log"

// Useful functions
#define max(a,b) ((a) > (b) ? (a) : (b))
 
#endif

