#! &PERL& -I&INCDIR&
# ----------

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use Lastlib;
use Getopt::Long;


#######################################################################
# Command Line Processing
#######################################################################

$result = GetOptions('stime:i',		\$stime,	# <start time>
		     'dur:i',		\$dur,		# <duration>
		     'count:i', 	\$count,	# <count>
		     'ttyp:s',		\@ttyp,		# <ttyp>
		     'host:s',		\@hosts, 	# <host>
		     'usr:s', 		\@usr,		# <user>
                     'match:s',         \$match);       # <match>

 
if ($result  == 0)  { print "Command line Error \n"; }
if ($stime eq "") { $time_bound = 0;     } else { $time_bound = $stime;   }
if ($dur   eq "") { $duration_bound = 0; } else { $duration_bound = $dur; }
if ($count  > 0 ) { $count = join ('',"-",$count); } else { $count = "";  }
	
if (@hosts == 0) { $host_option = 0; } else { $host_option = 1; }
if (@ttyp  == 0) { $ttyp_option = 0; } else { $ttyp_option = 1; }

if (($host_option) && ($ttyp_option)) {
    $host_option = 0;
    $ttyp_option = 0;
    $host_ttyp_option = 1;
}   
   



#######################################################################
# Create LoL and Parse
#######################################################################
	
create_LoL($count, @usr);

 @sample = ();
 @buffer = ();

 for  $index ( 0..$#data ) {
    $slice = -9;

    if ($data[$index][$tty_index] eq "console") { 
	sub_index_decrement();
	$flag = 1;	
    }
 
    time_stamp_strip($index);
    duration_stamp_strip($index);
  
    if ($host_ttyp_option) {
       if ((&time_filter) && (&host_filter) && (&ttyp_filter)) { $slice = $index; }
    }
    elsif ($host_option) {
       if ((&time_filter) && (&host_filter)) { $slice = $index; }
    }
    elsif ($ttyp_option) {
       if ((&time_filter) && (&ttyp_filter)) { $slice = $index; }
    }
    else {
	if (&time_filter) { $slice = $index; }
    }


    if ($slice >= 0) {
	 @buffer = @{ $data[$index] } [0..$duration_index];
	 push (@sample, @buffer);
	 push (@sample, "\n");

	 if ($match ne "") {                   # match expressions according
	     $match--;                         # to delimiter
	 }					       
     }
    
   
    if ($flag) {
	sub_index_increment();
	$flag = 0;
    }

   if ($match == 0) {                          # if final match exit and print
       last;
   } 
}

for $i ( 0 .. $#sample) {
	print "\t $sample[$i]";
}




#######################################################################
# Check: LoL host vs. Command line host 
#######################################################################

sub host_filter {
 local($continue);
 $continue = 0;
  foreach $host (@hosts) {
     if ($data[$index][$host_index] =~ $host) { 
	$continue = 1; 
     }
  }
 $continue;
}



#######################################################################
# Check: LoL ttyp vs. Command line ttyp 
#######################################################################
 
sub ttyp_filter {
 local($continue);
 $continue = 0;
  foreach $tty (@ttyp) {
     if ($data[$index][$tty_index] =~ $tty) { 
	$continue = 1; 
     }
  }
 $continue;
}



#######################################################################
# Check: LoL stime and duration vs. Command line || default
#######################################################################
 
sub time_filter {
 local($continue);
 $continue = 0;
   if (($data[$index][$stime_index] >= $time_bound)  &&
       ($data[$index][$duration_index] >= $duration_bound)) {
    	 $continue= 1;	
    }
 $continue;
}
