import java.awt.*;

public class Constrain extends Frame {


  // *********************************************************************************
  // void constrain(Container container, Component component,
  //                int grid_x, int grid_y, int grid_width, int grid_height,
  //                int fill, int anchor, double weight_x, double weight_y,   
  //                int top, int left, int bottom, int right)
  //
  // Method Description:  This method will layout the component passed to it using the
  // GridBagLayout manager and methods native to it.  This method was extracted 
  // entirely from Oreilly's Java in a Nutshell by David Flanagan, page 111-112.
  //
  // Method Specification: This method lays out components for the GridBagLayout
  // manager using the GridBagConstraints class.  It lays out the component that
  // was passed to it.  The constraints layed out are:  container, component, 
  // grid_x, grid_y, grid_width, grid_height, anchor, weight_x, weight_y, and the
  // constraint insets are composed from top, left, bottom, right.
  //
  // This method will be accessed several times.
  //
  // Pre-Condition: The component has been instantiated, and the container has been
  // instantiated and set to the GridBagLayout manager.
  //
  // Post-Condition: None.  The component has been placed in the container.
  // 
  // *********************************************************************************
 
  public void constrain(Container container, Component component,
			int grid_x, int grid_y, int grid_width, int grid_height,
			int fill, int anchor, double weight_x, double weight_y,   
			int top, int left, int bottom, int right) {
    
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = grid_x;
    c.gridy = grid_y;
    c.gridwidth = grid_width;
    c.gridheight = grid_height;
    c.fill = fill;
    c.anchor = anchor;
    c.weightx = weight_x;
    c.weighty = weight_y;
    if (top+bottom+left+right>0)
      c.insets = new Insets(top, left, bottom, right);
    
    ((GridBagLayout)container.getLayout()).setConstraints(component, c);
    container.add(component);

  } // constrain
            


  // *********************************************************************************
  //  public void constrain(Container container, Component component,
  //			int grid_x, int grid_y, int grid_width, int grid_height) {
  // 
  // Method Description:  This method will layout the component passed to it using the
  // GridBagLayout manager and methods native to it.  This method was extracted 
  // entirely from Oreilly's Java in a Nutshell by David Flanagan, page 111-112.
  //
  // Method Specification: This method lays out components for the GridBagLayout
  // manager using the GridBagConstraints class.  It lays out the component that
  // was passed to it.   The constraints layed out are:  container, component, 
  // grid_x, grid_y, grid_width, grid_height.
  //
  // This method will be accessed several times.
  //
  // Pre-Condition: The component has been instantiated, and the container has been
  // instantiated and set to the GridBagLayout manager.
  //
  // Post-Condition: None.  The component has been placed in the container.
  // 
  // *********************************************************************************

  public void constrain(Container container, Component component,
			int grid_x, int grid_y, int grid_width, int grid_height) {
    
    constrain(container, component, grid_x, grid_y, grid_width,
	      grid_height, GridBagConstraints.NONE, 
	      GridBagConstraints.NORTHWEST, 0.0,0.0, 0,0,0,0);

  } // constrain



  // *********************************************************************************
  //  public void constrain(Container container, Component component,
  //			int grid_x, int grid_y, int grid_width, int grid_height,
  //			int top, int left, int bottom, int right) {
  // 
  // Method Description:  This method will layout the component passed to it using the
  // GridBagLayout manager and methods native to it.  This method was extracted 
  // entirely from Oreilly's Java in a Nutshell by David Flanagan, page 111-112.
  //
  // Method Specification: This method lays out components for the GridBagLayout
  // manager using the GridBagConstraints class.  It lays out the component that
  // was passed to it.   The constraints layed out are:  container, component, 
  // grid_x, grid_y, grid_width, grid_height, and top, left, bottom, right.
  //
  // This method will be accessed several times.
  //
  // Pre-Condition: The component has been instantiated, and the container has been
  // instantiated and set to the GridBagLayout manager.
  //
  // Post-Condition: None.  The component has been placed in the container.
  // 
  // *********************************************************************************

  public void constrain(Container container, Component component,
			int grid_x, int grid_y, int grid_width, int grid_height,
			int top, int left, int bottom, int right) {
            
    constrain(container, component, grid_x, grid_y, grid_width,
	      grid_height, GridBagConstraints.NONE,
	      GridBagConstraints.NORTHWEST, 0.0,0.0, top, left,
	      bottom, right);
  } // constrain

}





