CREATE TABLE log (
	trust int,
	coop int,
	integ int,
	ldate date,
	ltime time,
	description text,
	hostip text,
	file text,
	tool text
);

CREATE TABLE filter (
	expression text,
	date_start date,
	date_end date,
	time_start time,
	time_end time,
	trust int,
	coop int,
	integ int,
	log int,
	alert int,
	inh int
);

CREATE TABLE accept_list (
	filter text,
	start_addr text,
	end_addr text,
	inh int
);

CREATE TABLE forward_list (
	filter text,
	host text,
	inh int
);

CREATE TABLE forward_peer (
	filter text,
	pgroup text,
	inh int
);

CREATE TABLE manager (
	manager text
);

CREATE TABLE levels (
	start_addr text,
	end_addr text,
	trust int,
	coop int,
	integ int,
	inh int
);

CREATE TABLE config_time (
	ctime int
);

CREATE TABLE subordinates (
	hum_name text,
	subord text
);

CREATE TABLE pid (
	name text,
	pid int
);

CREATE TABLE kill_file (
	start_addr text,
	end_addr text,
	inh int
);

CREATE TABLE pgroups (
	pgroup text,
	mod_addr text,
	email text
);

CREATE TABLE peers (
	pgroup text,
	mem_addr text,
     	peer_sub int,
        peer_mod int
);

CREATE TABLE message (
	pgroup text,
	mem_addr text,
	action text,
	rdate date,
	rtime time,
	status int,
	sdate date,
	stime time,
	mpublic int
);
