.TH HUMMER 1 "Jan 28, 1997" "HUMMER" "HUMMER"

.\"
.\" Hummer manual page.
.\" Author: Jamie Marconi <marc9442@cs.uidaho.edu>
.\"

.SH NAME
Hummer \- HummingBird Distributed Intrusion Detection System

.SH SYNOPSIS
Any \fIHummer\fP command.

.SH DESCRIPTION
HummingBird is an Intrusion Detection System for large networks.  The System
collects activity logs from local systems and forwards them to managing
systems.  In this way a single system administrator could collect misuse data
about a large network of computers.

The following is terminology used to describe HummingBird:

.TP 8
.B "Peer" 
a relationship of equals between hosts. Neither host controls the other,
although they may send requests or information between themselves. Peers do
not necessarily trust one another, and the level of trust is not
necessarily identical.
.TP 8
.B "Manager"
a manager is a host that provides instructions regarding which data is to be
collected, when warnings should be issued, etc. to a set of dependent
hosts. Managers set a central policy for a group of hosts. Managers need not
trust their subordinate hosts.
.TP 8
.B "Subordinate/Managed Host"
a host that receives some or all of its data collection and transmission
policy from outside.  Managed hosts may modify or add to this policy, and may
themselves manage other hosts. Managed hosts must fully trust their managers,
and will usually be within the same policy domain.
.TP 8
.B "Hummer"
A set of agents that run on individual hosts in the same or different
environments. Activities performed by a hummer include: data collection, data
sharing, authentication.

.TP 8
.B "Trust Level"
Trust levels are values assigned to messages coming from other Hummers. The
trust levels range from 1 to 5. A value of 1 means most trusted and a value
of 5 means least trusted. These values can be assigned to a single IP address
or a range of IP addresses. The trust values are used by message filters. If
an incoming message has a trust equal to or greater than the trust level
assigned to the filter, and the other message filter parameters are met, it
will act on the message.

.TP 8
.B "Integrity Level"
Integrity levels are values assigned to messages coming from other Hummers.
The integrity levels range from 1 to 5. These values can be assigned to a
single IP address or a range of IP addresses.  A value of 1 means the
information in the incomming message is most likely to have been collected
correctly and accurately.  A value of 5 means the information in the incoming
message is least likely to have been collected correctly and accurately.

.SH EXAMPLES
To start a hummer make your working directory the installation directory then
run:
.sp
.nf
    % Interface &
    % starthum
.fi

To stop the hummer run:
.sp
.nf
    % stophum
.fi

\fIstophum\fP will show a list of processes and pids it killed.

To use the configuration interface to Hummer you must have started the Hummer
with the \fIstarthum\fP command.  Next you will need to start your web
browser and enter the URL:
.sp
.nf
    http://localhost:15000/index.shtml
.fi

Follow the instructions to configure the Hummer from the web pages.

.SH SEE ALSO
Server(1), ConClient(1), ConServ(1), ToolI(1) 

.SH AUTHOR
Jamie Marconi, University of Idaho Department of Computer Science