/******************************************************************
krb5_sock_serv.h
HummingBird Project - Deborah A. Frincke, PhD.
Summer 1997
Coded by: Jamie Marconi
Description: This class is used for kreberized server ports.
*******************************************************************/
/*
  Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _krb5_sock_serv_h
#define _krb5_sock_serv_h

#include "krb5_sock.h" // kerberos socket base class
#include "krb5_sock_cli.h"
#include <stdlib.h>
#include <stdio.h>

class krb5_sock_serv: public krb5_sock
{
  //Data;
  int sin_len;
  int asock;
  krb5_keytab keytab;

  //Methods;
 public:
  krb5_sock_serv();
  ~krb5_sock_serv();
  int krb5_listen(int max_connections);
  int krb5_accept(void);
  char * krb5_m_auth(char *keytab_name);
  int krb5_get_asock(void);
  void krb5_get_rmt_addr(char *buf);
  krb5_sock_cli *krb5_mk_cli();
  int krb5_e_read(char *buf, size_t buflen);
  int krb5_e_write(char *buf);
  int krb5_closea();
};

#endif /* _krb5_sock_serv_h */
