/*
  Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <config.h>

#ifdef KERBEROS

#include "krb5_sock_serv.h"
#include "krb5_sock_cli.h"

#endif /* KERBEROS */

#include <sys/wait.h>

main()
{
#ifdef KERBEROS
  signal(SIGCHLD, SIG_IGN);
  krb5_sock_serv *InSocket;
  InSocket = new krb5_sock_serv();

  InSocket->krb5_create();
  char *service = "simple";
  if (!InSocket->krb5_bind(15005, service)) {
    fprintf (stderr, "Socket Bind Error.  Is the server already running.\n");
    exit(1);
  }
  InSocket->krb5_listen(SOMAXCONN);

  while (1) {
    InSocket->krb5_accept();
    krb5_sock_cli *OutSocket = InSocket->krb5_mk_cli();

    if (fork() == 0) {
      InSocket->krb5_close();
      if (OutSocket->krb5_r_auth("./krb5_sock_test_serv.keytab")) {
	
	char *buf;
	buf = new char[1024];
	do {
	  OutSocket->krb5_e_read(buf, 1024);
	  cout << buf << endl;
	} while (buf[0] != 'E');
	OutSocket->krb5_e_write("I am server hear me squeek.\n");
	
      }
      OutSocket->krb5_close();
      delete OutSocket;
      exit(0);
    }
    
    else {
      OutSocket->krb5_close();
    }

  }

  InSocket->krb5_close();
  delete InSocket;

#endif /* KERBEROS */

  return 0;
}


