#! &PERL&

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#

use CGI qw(:standard);
use Pg;
use strict;

use Sys::Hostname;
my $host = hostname();

my $conn = Pg::connectdb("dbname = hummer_$host");
( PGRES_CONNECTION_OK eq $conn->status ) || die "connection:$!";
my $result;
my $inh = param('inh');


print header;
print start_html(-title=>'Messaging Configuration',
		 -TEXT=>'black', 
		 -BGCOLOR=>'white',
		 -LINK=>'blue',
		 -VLINK=>'purple');
print "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
  h1('Messaging Configuration'),
  "<H3><A HREF=\"filterhelp.html\">Help</A></H3>",
  "<H4><A HREF=\"filters.shtml\">Return to Message Configuration Page</A></H4>",hr,
  "</center>";

if ($inh eq "") {
  print h2('Error: Must specify inherited value');
}
else {
  if (!param('Action')) {
    print "<center>",
    start_form,
    hidden(-name=>'inh',-default=>["$inh"]),
    "<H2>Modify Filter</H2>",
    "<H4>Regular Expression:<INPUT type=text name=regexp size=30></h4>",
    hr,
    "<table border=0 cellpadding=10>",
    "<tr><td>",
    "<H3>Filters</H3>",
    hr,
    "Date  MM-DD-YYYY<BR><BR>",
    "Begin:<INPUT type=text name=date1 size=10>",
    "End:<INPUT type=text name=date2 size=10><BR><BR>",
    "Time HH:MM:SS<BR><BR>",
    "Begin:<INPUT type=text name=time1 size=8>",
    "End:<INPUT type=text name=time2 size=8><BR><BR>",
    
    "Trust Level: ", popup_menu(-name=>'trust',
				-values=> [ 'NULL', '1', '2', '3', '4', '5' ],
			       ),br,

    "Cooperation Level: ", popup_menu(-name=>'coop',
				      -values=> [ 'NULL', '1' , '2', '3', '4', '5' ],
				     ),br,
    
    "Integrity Level: ", popup_menu(-name=>'integ',
				    -values=> [ 'NULL', '1' , '2', '3', '4', '5' ],
				   ),br,
    "Messages accepted from:<BR><BR>";

    print "<TEXTAREA name=accept rows=5 cols=35>";
    print "</TEXTAREA>";
    
    print "</td><td><H3>Actions and Alerts</h3>",
    hr,
    "<INPUT type=checkbox name=local>Log Locally<BR><BR>",
    "<INPUT type=checkbox name=alert>Alert this Console<BR><BR>",
    "Forward this message to the Hummers:<BR><BR>";
    
    print "<TEXTAREA name=forwards rows=5 cols=35>";
    print "</TEXTAREA>",br,br;

    $result = $conn->exec("select * from pgroups;");
    (PGRES_TUPLES_OK eq $result->resultStatus) || die "pgroups:$!";

    my @groupnames;
    my $i;
    for ($i=0; $i < $result->ntuples; $i++) {
      $groupnames[$i] = $result->getvalue($i,0);
    }
    
    print "Forward this message to the Peer Groups:",br,br,
    
    scrolling_list(-name=>'forward_peer',
		   -values=>[ @groupnames ],
		   -size=>5,
		   -multiple=>'true');
    
    print "</td></tr></table>",
    hr,
    submit('Action','Configure'),
    reset(),
    button(-value=>'Cancel',
	   -onclick=>"history.back()"),
    end_form,
    "</center>\n";
  }
  else {
    my $regexp = param('regexp');
    my $start_date = param('date1');
    if ($start_date eq "") { $start_date = "NULL" }
    else { $start_date = "'$start_date'"; }
    my $end_date = param('date2');
    if ($end_date eq "") { $end_date = "NULL" }
    else { $end_date = "'$end_date'"; }
    my $start_time = param('time1');
    if ($start_time eq "") { $start_time = "NULL" }
    else { $start_time = "'$start_time'"; }
    my $end_time = param('time2');
    if ($end_time eq "") { $end_time = "NULL" }
    else { $end_time = "'$end_time'"; }
    my $trust = param('trust');
    my $coop = param('coop');
    my $integ = param('integ');
    my $accept = param('accept');
    my $log = param('local');
    if ($log) { $log = 1 } else { $log = 0; }
    my $alert = param('alert');
    if ($alert) { $alert = 1 } else { $alert = 0; }
    my $forwards = param('forwards');
   
    my @forward_peer = param('forward_peer');

    
    $result = $conn->exec("delete from filter where expression = '$regexp' and inh = $inh;");
    (PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
    $result = $conn->exec("delete from forward_list where filter = '$regexp' and inh = $inh;");
    (PGRES_COMMAND_OK eq $result->resultStatus) || die "select forward:$!";
    $result = $conn->exec("delete from accept_list where filter = '$regexp' and inh = $inh;");
    (PGRES_COMMAND_OK eq $result->resultStatus) || die "select accept_list:$!";
    $result = $conn->exec("delete from forward_peer where filter = '$regexp' and inh = $inh;");
    (PGRES_COMMAND_OK eq $result->resultStatus) || die "select forward_peer:$!";

    $result = $conn->exec("insert into filter values (
            '$regexp',
            $start_date,
            $end_date,
            $start_time,
            $end_time,
            $trust,
            $coop,
            $integ,
            $log,
            $alert,
            $inh);");
    (PGRES_COMMAND_OK eq $result->resultStatus) || die $!;
        
    my $forw;
    my $acc;
    
    foreach $forw (split(/$/m, $forwards)) {
      $forw =~ s/\n//;
      $forw =~ s/\r//;
      if ($forw ne "") {
	$result = $conn->exec("insert into forward_list values ('$regexp','$forw', $inh);");
	(PGRES_COMMAND_OK eq $result->resultStatus) || die "insert forward_list:$!";
	#print "insert into forward_list values ('$regexp','$forw', $inh);<br>\n";
      }
    }
    foreach  $acc (split(/$/m, $accept)) {
      $acc =~ s/\n//;
      $acc =~ s/\r//;
      if ($acc ne "") {
	my $start;
	my $end;
	($start, $end) = split( /-/, $acc);
	if ($end eq "") {
	  $result = $conn->exec("insert into accept_list values('$regexp','$start', NULL, $inh);");
	  (PGRES_COMMAND_OK eq $result->resultStatus) || die "insert accept_list1:$!";
	}
	else {
	  $result = $conn->exec("insert into accept_list values('$regexp','$start', '$end', $inh);");
	  (PGRES_COMMAND_OK eq $result->resultStatus) || die "insert accept_list2:$!";
	}
	#print "insert into accept_list values ('$regexp','$start', '$end', $inh);\n<br>";
      }
    }
    my $i;
    for ($i=0; $i<=$#forward_peer; $i++) {
      $result = $conn->exec("insert into forward_peer values ('$regexp', '$forward_peer[$i]', $inh);");
      (PGRES_COMMAND_OK eq $result->resultStatus) || die "insert forward_peer:$!";
    }
    print h2("<CENTER>The filter for $regexp is now added.</center>"),
    br,br;

    $result = $conn->exec("select * from filter where expression = '$regexp' and inh = $inh;");
#    $expression = $result->getvalue(0,$result->fnumber("expression"));
    $start_date = $result->getvalue(0,$result->fnumber("date_start"));
    $end_date = $result->getvalue(0,$result->fnumber("date_end"));
    $start_time = $result->getvalue(0,$result->fnumber("time_start"));
    $end_time = $result->getvalue(0,$result->fnumber("time_end"));
    $trust = $result->getvalue(0,$result->fnumber("trust"));
    $coop = $result->getvalue(0,$result->fnumber("coop"));
    $integ = $result->getvalue(0,$result->fnumber("integ"));
    $alert = $result->getvalue(0,$result->fnumber("alert"));
    if ($alert) { $alert = "TRUE"; } else { $alert = "FALSE"; }
    my $log = $result->getvalue(0,$result->fnumber("log"));
    if ($log) { $log = "TRUE"; } else { $log = "FALSE"; }

    print "<TABLE border=0 cellpadding=10>";
    print "<H2> The following parameters have been assigned:  </H2><BR><BR>";
    print "<H3><DL><DD>";
    print "Start Date: ";
    if($start_date == "NULL") {print "NULL";} else {print "$start_date";} print "<BR>";
    print "End Date: ";
    if($end_date == "NULL") {print "NULL";} else {print "$end_date";} print "<BR><BR>";
    print "Start Time:  ";
    if($start_time == "NULL") {print "NULL";} else {print "$start_time";} print "<BR>";
    print "End Time:  ";
    if($end_time == "NULL") {print "NULL";} else {print "$end_time";} print "<BR><BR>";
    print "Trust Level:        ";
    if($trust == "NULL") {print "NULL";} else {print "$trust";} print "<BR>";  
    print "Cooperation Level:  ";
    if($coop == "NULL") {print "NULL";} else {print "$coop";} print "<BR>";  
    print "Integrity Level:    ";
    if($integ == "NULL") {print "NULL";} else {print "$integ";} print "<BR><BR>";  
    print "Messages Accepted From: ";
     $result=$conn->exec("select * from accept_list where filter = '$regexp';");
      if(($result->ntuples) == 0)
      {print"NONE SELECTED";}
     else{	
           for($i = 0; $i<=$result->ntuples; $i++){
	  my  $accept_name = $result->getvalue($i,1);
	    print"$accept_name";
                   print" ,";}
       }
    print "<BR><BR>";
    print "Log Locally:  $log<BR>";
    print "Alert this Console:  $alert<BR><BR>";
    print "Forward this Message to the Hummers: ";
  
    $result=$conn->exec("select * from forward_list where filter = '$regexp';");
      if(($result->ntuples) == 0)
      {print"NO HUMMERS SELECTED";}
     else{	
           for($i = 0; $i<=$result->ntuples; $i++){
	  my  $forward_name = $result->getvalue($i,1);
	    print"$forward_name";
                   print" ,";}
       }
    print"<BR><BR>";
    
    print "Forward this Message to the Peer Groups:  ";
    if($#forward_peer  < 1)
    {print"NO PEER GROUPS SELECTED";}
    else
      { for($i = 0; $i<=$#forward_peer; $i++){
	  print"$forward_peer[$i]";
                 print" ,";}
      }
    print "</H3><BR><BR></TABLE>";
  }
}
  
#print "<A HREF=\"filters.shtml\">Return to Message Configuration Page</A>";
print end_html;
