#! &PERL&

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

# demo script, has been tested with:
#  - Postgres-6.1
#  - apache_1.2
#  - mod_perl-1.0
#  - perl5.004

use CGI qw(:standard);
use Pg;
use strict;

use Sys::Hostname;
my $host = hostname();

my $conn = Pg::connectdb("dbname = hummer_$host");
( PGRES_CONNECTION_OK eq $conn->status ) || exit;
my $result;
my $inh = param('inh');

print header;
print start_html(-title=>'Levels Modification',
		 -TEXT=>'black', 
		 -BGCOLOR=>'white',
		 -LINK=>'blue',
		 -VLINK=>'purple');
print "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
  h2('Levels Modification'),a({href=>"levels_mod__help.html"},"<H3>Help</H3>"),
  "<H4><A HREF=\"levels.shtml\">Return to Levels Configuration Page</A><H4>",
  hr;

if ($inh eq "") {
  print h2('Error: Must specify inherited value');
}
else {
  $result = $conn->exec("SELECT * FROM levels where inh = $inh;");
  (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
  
  my @levels;
  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
    $levels[$i] = $result->getvalue($i,0);
    if ($result->getvalue($i, 1)) {
      $levels[$i] = $levels[$i] . "-" . $result->getvalue($i, 1); 
    }
   # $trusts[$i] = $trusts[$i] . "--" . $result->getvalue($i, 2);
  }

  my $hosts;
  if (!param('hosts')) {
    $hosts = $levels[0];
  }
  else {
    $hosts = param('hosts');
  }

  my $start_addr;
  my $end_addr;
  ($start_addr, $end_addr) = split(/-/, $hosts);
  
  if (!param('Action')) {
    $result = $conn->exec("SELECT * FROM levels
                         where inh = $inh 
                         AND start_addr ='$start_addr' 
                         AND end_addr = '$end_addr';");

    (PGRES_TUPLES_OK eq $result->resultStatus) || exit;

    my $trust = $result->getvalue(0,2);
    my $coop = $result->getvalue(0,3);
    my $integ = $result->getvalue(0,4);
    
    print h4('Currently Selected Hummer'),
    start_form,
    hidden(-name=>'inh',-default=>["$inh"]),
    popup_menu(-name=>'hosts',
	       -values=> [ @levels ],
	       -onChange=>'submit()');
    
    print "<hr><h3>Select an Action:</h3>";
    print "<TABLE border=0 cellpadding=10>",
    "<TR><TD><a href=\"addlevel.cgi?inh=$inh\">Add a New Hummer and Levels</a></TD></TR>",
    "<TR><TD><INPUT type=\"radio\" name=\"tconfig\" value=\"trem\">Remove the Selected Hummer</TD></TR>",
    "<TR><TD><INPUT type=\"radio\" name=\"tconfig\" value=\"tmod\" CHECKED>Change Selected Levels</TD>",
    "<TD>",
    
    "Trust Level: ", popup_menu(-name=>'trust',
				-values=> [ '1', '2', '3', '4', '5' ],
				-default=>"$trust",
				-override=>1
			       ),br,
    
    "Cooperation Level: ", popup_menu(-name=>'coop',
				      -values=> [ '1' , '2', '3', '4', '5' ],
				      -default=>"$coop",
				      -override=>1
				     ),br,
    
    "Integrite Level: ", popup_menu(-name=>'integ',
				    -values=> [ '1' , '2', '3', '4', '5' ],
				    -default=>"$integ",
				    -override=>1
				   ),br,
    
    "</TD></TR>",
    "</TABLE>",
    
    submit('Action','Configure'),
    reset(), 
    button(-value=>'Cancel',
	   -onclick=>"history.back()"),
    end_form,
    "</center>";
  }
  else {
    my $trust = param('trust');
    my $coop = param('coop');
    my $integ = param('integ');
    my $tconfig = param('tconfig');
    
    if ($tconfig eq "trem") {
      $result = $conn->exec("delete from levels \n
           where \n
             start_addr = '$start_addr'\n
             and end_addr = '$end_addr' \n
             and inh = $inh;");
      # print "delete from trust <br>
      #           where <br>
      #             start_addr = '$start_addr'<br>
      #             and end_addr = '$end_addr' <br>
      #             and level = $level <br>
      #             and inh = $inh;<br><br>";
      (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
    }
    
    if ($tconfig eq "tmod") 
    {
      $result = $conn->exec("delete from levels where start_addr = '$start_addr' and end_addr = '$end_addr' and inh = $inh;");
      (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
      my $result = $conn->exec("insert into levels values ('$start_addr','$end_addr',$trust, $coop, $integ, $inh);");
      
#    $result = $conn->exec("update levels set trust = $trust, coop = $coop, integ = $integ\n
#           where \n
#             start_addr = '$start_addr'\n
#             and end_addr = '$end_addr'\n
#             and inh = $inh;\n");
      print "update levels set trust = $trust , coop = $coop , integ = $integ\n
           where \n
             start_addr = '$start_addr'\n
             and end_addr = '$end_addr'\n
             and inh = $inh;\n";
      (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
    }
    print h2('Changes made sucessfully');
  }
}


print "</center>";
print end_html;
  
