/******************************************************************
sock_serv.h
HummingBird Project - Deborah A. Frincke, PhD.
Spring 1998
Coded by: Jamie Marconi
Description: This class is used for server ports.
*******************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef sock_serv_h
#define sock_serv_h

#include "sock.h"
#include "sock_cli.h"

#define LISTEN_BACKLOG 10

class sock_serv: public sock
{
  //Data;
  int asock;

  //Methods;
 public:
  sock_serv();
  sock_serv(char *pservice, int listen_backlog = LISTEN_BACKLOG);
  sock_serv(int pport, int listen_backlog = LISTEN_BACKLOG);
  sock_serv(int pport, char *pservice, int listen_backlog = LISTEN_BACKLOG); 
  ~sock_serv();
  int bind(int pport);
  int bind(char *pservice);
  int bind(int pport, char *pservice);
  int listen(int listen_backlog = LISTEN_BACKLOG);
  int accept(void);
  int get_asock(void);
  void get_rmt_addr(char *buf);
  sock_cli *make_sock_cli();
  int close_a();
};

#endif /* _sock_serv_h */
