#! &PERL& -I&INCDIR&
# -*- perl -*-
#must include this line to use perl v5.002 on this system.

 ##############################################################
 #      Hummingbird  (Team A)
 #      05/29/97
 #      Dean Polla
 #
 #  This tool is designed to parse the system log and send all
 #  relevant information to its hummer.  The system log is the 
 #  location of the telnetd, fingerd, and the rlogin reports.
 #
 ##############################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use Toollib;
use Datelib qw($year);

forktoBg($0);
$logfile = "&SYSLOG&";
&parseData();
&delpid();


#################################################################
# This subroutine will parse the information in the log file
# and call 'ToolI'   
#################################################################
   
sub parseData {
  open (LOG,$logfile) || die "Can't open $logfile.\n";
   
  # Seeks to the end of the file and clears the end of file pointer
  seek LOG,0,2;
  seek LOG,0,1;

while (!$do_exit) {
  while (<LOG>) {
   chop;                # removes the end of line marker from the string

   #splits the date stamp for formatting
   ($month,$dd,$time,$site,$daemon,$msg) = split(/ +/,$_,6);
	
   if ($dd < 10) { $dd = "0". $dd; }

   #convert month into a number format.
   $month = atoiMonth($month);
 
   #creates the date stamp for the message
   $yyyymmdd = join('', $year,$month,$dd);
             
   #remove the ':' from the time stamp
   $time =~ s/://g;

   #just collect the desired info: ftp, su, ssh
   if ($msg =~ /ftp.login.from/i || /logged.out/i || /login.incorrect/i ||
		/su.\:.\-/ || /ssh/i || /login/i) {
 
     #joins the log info into a message so it can be filtered and logged.
     $msngr = join (' ',$daemon,$msg);
                
     ToolI($msngr, $yyyymmdd, $time, $hostname, $logfile, "systool");

   }     
 }
        
   #reads to end of the file, waits 15 sec for new info to arrive, 
   #then removes the end of file marker and tries to read again
     sleep $sleepTime;
     seek LOG,0,1;
}               
close(LOG);
}
