#!/bin/sh
# 
# regress.sh
#
# Author: Jamie Marconi <marc9442@cs.uidaho.edu>
#

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

if echo '\c' | grep -s c >/dev/null 2>&1
then
        ECHO_N="echo -n"
        ECHO_C=""
else
        ECHO_N="echo"
        ECHO_C='\c'
fi

if [ -d ./obj ]; then
        cd ./obj
fi

echo "=============== Notes...                              ================="
echo "The HummingBird system should not be running while running these tests"
echo "normally much of the configuration information is destroyed when the"
echo "tests are run."
echo "postmaster must already be running for the regression tests to succeed."
echo ""
echo "================ running regression test...          =================="
for i in `cat test.list`
do
        $ECHO_N "${i} .. " $ECHO_C
        tests/${i}.test > results/${i}.out 2>&1
        if [ `diff expected/${i}.out results/${i}.out | wc -l` -ne 0 ]
        then
                echo failed
        else
                echo ok
        fi
done
exit
